RequirePackage("require_file");
AddToLoadPath("~/research/symbal/src");
AddToLoadPath("../cube");

ReadFile("cube.gap");
ReadFile("perturb.gap");

orbDFS:=function(dim,inf)
    local V,G,H,Vp,results;
    V:=CubeVerts(dim);
    
    G:=orthoPermGroup(dim);
    H:=bestLineStabilizer(G,V);

    Vp:=orbitLex2(V,H,DefaultInnerProduct,1/100000000);

    results:=dfs(Vp.matrix,Vp.group,
                       [ rec(VRepresentation:=false, 
                             infoLevel:=inf,
                         canonTest:=false,
                         dualFacetTrick:=false,
                         orbitLexPerturb:=false,
                             cobasisStabilizers:=false,
                         )]);
    FormatResults(results,"dimension");
    return results;
end;
