RequirePackage("require_file");
AddToLoadPath("~/research/symbal/src");
AddToLoadPath("../cube");

ReadFile("cube.gap");
ReadFile("perturb.gap");

V:=CubeVerts(4);

G:=orthoPermGroup(4);
H:=bestLineStabilizer(G,V);
#H:=projectGroup(G,V,[0,1,1,1,1],DefaultInnerProduct);
#Vp:=orbitLex(V,G,[0,1,1,1,1],DefaultInnerProduct,1/100000000);

globalResults:=dfs(V,H,
                   [ rec(VRepresentation:=false, 
                         canonTest:=false,
                         orbitLexPerturb:=true,
                         dualFacetTrick:=false,
                         startingCobasis:=[ 12, 14, 15, 16 ],
                         lexSigns:=List([1..Size(V)],j->-1),
                         cobasisStabilizers:=false,
                         infoLevel:=2,
                         gramVec:=true,
                         gramGraph:=true,
                         gramMotion:=true,
                        gramMotionViaGroup:=false,
                         gramMotionViaBrute:=true,
                         nautyIsometries:=true,
                         lexOnly:=false
                         )]);
FormatResults(globalResults,"dimension");
