RequireFile("perm-mat-group.gap");


homogenizeTransform:=function(M)
    local Mprime,row;
    
    row:=Concatenation([1],List(M[1],j->0));
    
    Mprime:=List(M,row->Concatenation([0],row));
    return Concatenation([row],Mprime);
end;

homogenizeVerts:=function(M)
    local Mprime;
    
    Mprime:=List(M,row->Concatenation([1],row));
    return Mprime;
end;



edgeSetToVec:=function(S,n)
    local vec;
    
    vec:=List([1..Binomial(n,2)],j->-1);
    vec{S}:=List([1..Size(S)],j->1);
    return vec;
end;

CutVerts:=function(n)
    local edges,edgeSets,verts;
    edges:=Combinations([1..n],2);
    
    edgeSets:=AsSet(List(Combinations([1..n]),
                   S->List(Filtered(edges,pair->
                           Number(pair,j->j in S)=1))));
    
    verts:=List(edgeSets,
                    L->edgeSetToVec(List(L,pair->Position(edges,pair)),n));
    return verts;
end;

# transform a vertex relabelling into an edge permutation
edgePerm:=function(pi,n)
    local edges,newEdges;
    
    edges:=Combinations([1..n],2);
    newEdges:=List(edges,e->Position(edges,OnSets(e,pi)));
    
    return MappingPermListList([1..Binomial(n,2)],newEdges);
end;
    

cutNodePerms:=function(n)
	return List(GeneratorsOfGroup(SymmetricGroup(n)),pi->edgePerm(pi,n));
end;

cutSwitchMats:=function(n)
    local verts,empty,gens;
    
    empty:=List([1..Binomial(n,2)],j->-1);
    
    verts:=Filtered(CutVerts(n),v->v <> empty);
    
    gens:=List(verts,v->DiagonalMat(-1*v));
    
    return gens;
end;
    
cutMatGroup:=function(n)
    local gens;
    
    gens:=cutSwitchMats(n);
    
    gens:=Concatenation(gens,
	List( cutNodePerms(n), pi->PermutationMat(pi, Binomial(n,2))));

    
    gens:=List(gens,T->homogenizeTransform(T));

    return Group( gens  );

end;


cutPermGroup:=function(dim)
    local G,V,PG;
    
    G:=cutMatGroup(dim);
    
    V:=homogenizeVerts(CutVerts(dim));
    PG:=PermGroupMatGroup(G,V);
    return PG;
end;

